#region License
/* Copyright 2004, 2013 James F. Bellinger
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redestribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must
 * not claim that you wrote the original software. If you use this software
 * in a product, an acknowledgement in the product documentation would be
 * appreciated but is not required.
 * 
 * 2. Altered source versions must be plainly marked as such, and must
 * not be misrepresented as being the original software.
 * 
 * 3. This notice may not be removed or altered from any source
 * distribution. */
#endregion

using System;

namespace Chatter.Plugins.Server
{
	/// <summary>
	/// Aids in loading and saving plugin settings.
	/// </summary>
	public interface ISettings
	{
		/// <summary>
		/// Loads plugin settings. The filename is determined by the plugin's
		/// assembly name.
		/// </summary>
		/// <param name="objectType">The type of the settings object.</param>
		/// <returns>Returns the deserialized settings object.</returns>
		object Load(Type objectType);

		/// <summary>
		/// Saves plugin settings. The filename is determined by the plugin's
		/// assembly name.
		/// </summary>
		/// <param name="settings">The settings object.</param>
		void Save(object settings);

		string ProgramDirectory { get; }
		string PluginDirectory  { get; }
	}
}